regina::GraphPair Class Reference
Standard 3-Manifolds

Represents a closed graph manifold formed by joining two bounded Seifert fibred spaces along a common torus. More...

`#include <manifold/graphpair.h>`

Inheritance diagram for regina::GraphPair:

## Public Member Functions

| GraphPair (SFSpace *sfs0, SFSpace *sfs1, long mat00, long mat01, long mat10, long mat11)
| Creates a new graph manifold as a pair of joined Seifert fibred spaces. More...
| GraphPair (SFSpace *sfs0, SFSpace *sfs1, const Matrix2 &matchingReln)
| Creates a new graph manifold as a pair of joined Seifert fibred spaces. More...
| ~GraphPair ()
| Destroys this structure along with the component Seifert fibred spaces and the matching matrix. More...
const SFSpace & | sfs (unsigned which) const
| Returns a reference to one of the two bounded Seifert fibred spaces that are joined together. More...
const Matrix2 & | matchingReln () const
| Returns a reference to the 2-by-2 matrix describing how the two Seifert fibred spaces are joined together. More...
bool | operator< (const GraphPair &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this space is "smaller" than the given representation of the given space. More...
AbelianGroup * | homology () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
bool | isHyperbolic () const
| Returns whether or not this is a finite-volume hyperbolic manifold. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the common name of this 3-manifold as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the common name of this 3-manifold in TeX format to the given output stream. More...
std::string | name () const
| Returns the common name of this 3-manifold as a human-readable string. More...
std::string | TeXName () const
| Returns the common name of this 3-manifold in TeX format. More...
std::string | structure () const
| Returns details of the structure of this 3-manifold that might not be evident from its common name. More...
virtual Triangulation< 3 > * | construct () const
| Returns a triangulation of this 3-manifold, if such a construction has been implemented. More...
AbelianGroup * | homologyH1 () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
bool | operator< (const Manifold &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold. More...
virtual std::ostream & | writeStructure (std::ostream &out) const
| Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream. More...
void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Detailed Description

Represents a closed graph manifold formed by joining two bounded Seifert fibred spaces along a common torus.

Each Seifert fibred space must have just one boundary component, corresponding to a puncture in the base orbifold (with no fibre-reversing twist as one travels around this boundary).

The way in which the two spaces are joined is specified by a 2-by-2 matrix M. This matrix expresses the locations of the fibres and base orbifold of the second Seifert fibred space in terms of the first.

More specifically, suppose that f0 and o0 are generators of the common torus, where f0 represents a directed fibre in the first Seifert fibred space and o0 represents the oriented boundary of the corresponding base orbifold. Likewise, let f1 and o1 be generators of the common torus representing a directed fibre and the base orbifold of the second Seifert fibred space. Then the curves f0, o0, f1 and o1 are related as follows:

        [f1]       [f0]
        [  ] = M * [  ]
        [o1]       [o0]

See the page on Notation for Seifert fibred spaces for details on some of the terminology used above.

The optional Manifold routine homology() is implemented, but the optional routine construct() is not.

Todo:
  Optimise: Speed up homology calculations involving orientable base spaces by adding rank afterwards, instead of adding generators for genus into the presentation matrix.

## Member Function Documentation

## detail()

std::string regina::Output< Manifold , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## str()

std::string regina::Output< Manifold , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:\n In addition to str(), this is also used as the
  Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## utf8()

std::string regina::Output< Manifold , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

The documentation for this class was generated from the following file:

- manifold/graphpair.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).